%This M-Function was created automatically by PSG Toolbox.
%See section "Special Subroutines in Toolbox -> User Subroutine in Toolbox" in PSG Help Manual.
%
%Input variables:
%
%Inputs                            PSG Type    PSG Object                   Location in Problem Statement                              Class
%matrix_obj_el_data                data        matrix_obj_el                linear(matrix_obj_el)                                      double
%matrix_obj_el_vars                vars        matrix_obj_el                linear(matrix_obj_el)                                      cell
%matrix_acreage_xa_data            data        matrix_acreage_xa            linearmulti(matrix_acreage_xa)                             double
%matrix_acreage_xa_vars            vars        matrix_acreage_xa            linearmulti(matrix_acreage_xa)                             cell
%matrix_scenarios_el_data          data        matrix_scenarios_el          var_risk(parameter_alpha, matrix_scenarios_el)             double
%matrix_scenarios_el_vars          vars        matrix_scenarios_el          var_risk(parameter_alpha, matrix_scenarios_el)             cell
%matrix_acreage_cotton_data        data        matrix_acreage_cotton        linear(matrix_acreage_cotton)                              double
%matrix_acreage_cotton_vars        vars        matrix_acreage_cotton        linear(matrix_acreage_cotton)                              cell
%matrix_acreage_peanut_data        data        matrix_acreage_peanut        linear(matrix_acreage_peanut)                              double
%matrix_acreage_peanut_vars        vars        matrix_acreage_peanut        linear(matrix_acreage_peanut)                              cell
%matrix_cardinality_cotton_data    data        matrix_cardinality_cotton    cardn_pos(parameter_alpha_1, matrix_cardinality_cotton)    double
%matrix_cardinality_cotton_vars    vars        matrix_cardinality_cotton    cardn_pos(parameter_alpha_1, matrix_cardinality_cotton)    cell
%matrix_cardinality_peanut_data    data        matrix_cardinality_peanut    cardn_pos(parameter_alpha_2, matrix_cardinality_peanut)    double
%matrix_cardinality_peanut_vars    vars        matrix_cardinality_peanut    cardn_pos(parameter_alpha_2, matrix_cardinality_peanut)    cell
%point_upperbounds_data            data        point_upperbounds            Box: >= parameter_bound_6, <= point_upperbounds            double
%point_upperbounds_vars            vars        point_upperbounds            Box: >= parameter_bound_6, <= point_upperbounds            cell
%parameter_bound_data              data        parameter_bound              Constraint: == parameter_bound                             double
%parameter_bound_1_data            data        parameter_bound_1            Constraint: == parameter_bound_1                           double
%parameter_bound_2_data            data        parameter_bound_2            Constraint: <= parameter_bound_2, linearize = 1            double
%parameter_alpha_data              data        parameter_alpha              var_risk(parameter_alpha, matrix_scenarios_el)             double
%parameter_bound_3_data            data        parameter_bound_3            Constraint: <= parameter_bound_3                           double
%parameter_bound_4_data            data        parameter_bound_4            Constraint: <= parameter_bound_4, linearize = 1            double
%parameter_alpha_1_data            data        parameter_alpha_1            cardn_pos(parameter_alpha_1, matrix_cardinality_cotton)    double
%parameter_bound_5_data            data        parameter_bound_5            Constraint: <= parameter_bound_5, linearize = 1            double
%parameter_alpha_2_data            data        parameter_alpha_2            cardn_pos(parameter_alpha_2, matrix_cardinality_peanut)    double
%parameter_bound_6_data            data        parameter_bound_6            Box: >= parameter_bound_6, <= point_upperbounds            double
%
%Output variables:
%
%solution_str = string with solution of problem;
%outargstruc_arr = array of output PSG data structures;


function [solution_str,outargstruc_arr] = Optimization_subroutine(matrix_obj_el_data,matrix_obj_el_vars,matrix_acreage_xa_data,matrix_acreage_xa_vars,matrix_scenarios_el_data,matrix_scenarios_el_vars,matrix_acreage_cotton_data,matrix_acreage_cotton_vars,matrix_acreage_peanut_data,matrix_acreage_peanut_vars,matrix_cardinality_cotton_data,matrix_cardinality_cotton_vars,matrix_cardinality_peanut_data,matrix_cardinality_peanut_vars,point_upperbounds_data,point_upperbounds_vars,parameter_bound_data,parameter_bound_1_data,parameter_bound_2_data,parameter_alpha_data,parameter_bound_3_data,parameter_bound_4_data,parameter_alpha_1_data,parameter_bound_5_data,parameter_alpha_2_data,parameter_bound_6_data)

%Pack data to PSG structure:
count = 0;
count = count+1;
iargstruc_arr(count) = matrix_pack('matrix_obj_el',matrix_obj_el_data,matrix_obj_el_vars,[],[]);
count = count+1;
iargstruc_arr(count) = matrix_pack('matrix_acreage_xa',matrix_acreage_xa_data,matrix_acreage_xa_vars,[],[]);
count = count+1;
iargstruc_arr(count) = matrix_pack('matrix_scenarios_el',matrix_scenarios_el_data,matrix_scenarios_el_vars,[],[]);
count = count+1;
iargstruc_arr(count) = matrix_pack('matrix_acreage_cotton',matrix_acreage_cotton_data,matrix_acreage_cotton_vars,[],[]);
count = count+1;
iargstruc_arr(count) = matrix_pack('matrix_acreage_peanut',matrix_acreage_peanut_data,matrix_acreage_peanut_vars,[],[]);
count = count+1;
iargstruc_arr(count) = matrix_pack('matrix_cardinality_cotton',matrix_cardinality_cotton_data,matrix_cardinality_cotton_vars,[],[]);
count = count+1;
iargstruc_arr(count) = matrix_pack('matrix_cardinality_peanut',matrix_cardinality_peanut_data,matrix_cardinality_peanut_vars,[],[]);
count = count+1;
iargstruc_arr(count) = point_pack('point_upperbounds',point_upperbounds_data,point_upperbounds_vars);
%Define problem statement:
problem_statement = sprintf('%s\n',...
'maximize',...
'  linear(matrix_obj_el)',...
'Constraint: == parameter_bound',...
'  linear(matrix_acreage_cotton)',...
'Constraint: == parameter_bound_1',...
'  linear(matrix_acreage_peanut)',...
'Constraint: <= parameter_bound_2, linearize = 1',...
'  var_risk(parameter_alpha, matrix_scenarios_el)',...
'Constraint: <= parameter_bound_3',...
'  linearmulti(matrix_acreage_xa)',...
'Constraint: <= parameter_bound_4, linearize = 1',...
'  cardn_pos(parameter_alpha_1, matrix_cardinality_cotton)',...
'Constraint: <= parameter_bound_5, linearize = 1',...
'  cardn_pos(parameter_alpha_2, matrix_cardinality_peanut)',...
'Box: >= parameter_bound_6, <= point_upperbounds',...
'Solver: stages = 30',...
' ');
%Change parameters with their values in problem statement:
problem_statement = strrep(problem_statement,'parameter_bound_1',num2str(parameter_bound_1_data));
problem_statement = strrep(problem_statement,'parameter_bound_2',num2str(parameter_bound_2_data));
problem_statement = strrep(problem_statement,'parameter_bound_3',num2str(parameter_bound_3_data));
problem_statement = strrep(problem_statement,'parameter_bound_4',num2str(parameter_bound_4_data));
problem_statement = strrep(problem_statement,'parameter_alpha_1',num2str(parameter_alpha_1_data));
problem_statement = strrep(problem_statement,'parameter_bound_5',num2str(parameter_bound_5_data));
problem_statement = strrep(problem_statement,'parameter_alpha_2',num2str(parameter_alpha_2_data));
problem_statement = strrep(problem_statement,'parameter_bound_6',num2str(parameter_bound_6_data));
problem_statement = strrep(problem_statement,'parameter_bound',num2str(parameter_bound_data));
problem_statement = strrep(problem_statement,'parameter_alpha',num2str(parameter_alpha_data));

%Optimize problem using mpsg_solver function:
[solution_str, outargstruc_arr] = mpsg_solver(problem_statement, iargstruc_arr);
results = psg_convert_outargstruc(solution_str,outargstruc_arr);
outargstruc_arr = results.data;
solution_str = results.string;

%=======================================================================|
%American Optimal Decisions, Inc. Copyright                             |
%Copyright American Optimal Decisions, Inc. 2007-2016.                 |
%American Optimal Decisions (AOD) retains copyrights to this material.  |
%                                                                       |
%Permission to reproduce this document and to prepare derivative works  |
%from this document for internal use is granted, provided the copyright |
%and No Warranty  statements are included with all reproductions       |
%and derivative works.                                                  |
%                                                                       |
%For information regarding external or commercial use of copyrighted    |
%materials owned by AOD, contact AOD at support@aorda.com.              |
%=======================================================================|
 

